<?php
header("Content-Type: text/html;charset=utf-8");

class cls_Tienda {

	private $db_mensaje = "";
	private $db_nombretabla = "tienda";
	private $db_nombrevista = "tienda";
	private $db_filas = "*";
	private $tienda_id = 0;
	private $nombre = "";
	private $imagen = "";
	private $ubicacion = "";
	private $telefono = "";
	private $observaciones = "";
	private $usuario_modificacion = 0;
	private $fecha_creacion = "";
	private $fecha_modificacion = "";
	private $activo = true;
	
	public function __construct(){
		$this->db_filas = "tienda_id, nombre, imagen, ubicacion, telefono, observaciones, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
	}

	static public function Indice($codigo){
		$current = new cls_Tienda();
		$conn = new cls_Conexion();
		$filtro = "tienda_id = ?";
		$values = array();
		array_push($values, $codigo );
		$lista = $conn->buscar_datos($current->db_nombrevista, $current->db_filas, $filtro, $values, "");
		$current->db_mensaje = $conn->getMensaje();
		for ($indice=0; $indice<count($lista); $indice++){
			$current->tienda_id = $lista[$indice]["tienda_id"];
			$current->nombre = $lista[$indice]["nombre"];
			$current->imagen = $lista[$indice]["imagen"];
			$current->ubicacion = $lista[$indice]["ubicacion"];
			$current->telefono = $lista[$indice]["telefono"];
			$current->observaciones = $lista[$indice]["observaciones"];
			$current->usuario_modificacion = $lista[$indice]["usuario_modificacion"];
			$current->fecha_creacion = $lista[$indice]["fecha_creacion"];
			$current->fecha_modificacion = $lista[$indice]["fecha_modificacion"];
			$current->activo = $lista[$indice]["activo"];
		}
		return $current;
	}

	public function get_tienda_id() { return $this->tienda_id; }
	public function get_nombre() { return $this->nombre; }
	public function get_imagen() { return $this->imagen; }
	public function get_ubicacion() { return $this->ubicacion; }
	public function get_telefono() { return $this->telefono; }
	public function get_observaciones() { return $this->observaciones; }
	public function get_usuario_modificacion(){  return $this->usuario_modificacion; }
	public function get_fecha_creacion(){  return $this->fecha_creacion; }
	public function get_fecha_modificacion(){  return $this->fecha_modificacion; }
	public function get_activo() { return $this->activo; }
	
	public function set_tienda_id($tienda_id){ $this->tienda_id = $tienda_id; }
	public function set_nombre($nombre){ $this->nombre = $nombre; }
	public function set_imagen($imagen){ $this->imagen = $imagen; }
	public function set_ubicacion($ubicacion){ $this->ubicacion = $ubicacion; }
	public function set_telefono($telefono){ $this->telefono = $telefono; }
	public function set_observaciones($observaciones){ $this->observaciones = $observaciones; }
	public function set_usuario_modificacion($usuario_modificacion){ $this->usuario_modificacion = $usuario_modificacion; }
	public function set_fecha_creacion($fecha_creacion){ $this->fecha_creacion = $fecha_creacion; }
	public function set_fecha_modificacion($fecha_modificacion){ $this->fecha_modificacion = $fecha_modificacion; }
	public function set_activo($activo){ $this->activo = $activo; }
	
	public function registrar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ( $this->tienda_id == 0 ){ // REGISTER
			array_push($values, $this->nombre);
			array_push($values, $this->imagen);
			array_push($values, $this->ubicacion);
			array_push($values, $this->telefono);
			array_push($values, $this->observaciones);
			array_push($values, $usuario_editor);
			$respuesta = $conn->nuevo_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
			if ( $respuesta ){
				$this->tienda_id = $conn->getlastId();
			}
		} else { // UPDATE
			array_push($values, $this->nombre);
			array_push($values, $this->imagen);
			array_push($values, $this->ubicacion);
			array_push($values, $this->telefono);
			array_push($values, $this->observaciones);
			array_push($values, $usuario_editor);
			array_push($values, $this->tienda_id);
			$respuesta = $conn->editar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		}
		return $respuesta;
	}
	
	public function importar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
			array_push($values, $this->tienda_id);
			array_push($values, $this->nombre);
			array_push($values, $this->imagen);
			array_push($values, $this->ubicacion);
			array_push($values, $this->telefono);
			array_push($values, $this->observaciones);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
		
			array_push($values, $this->nombre);
			array_push($values, $this->imagen);
			array_push($values, $this->ubicacion);
			array_push($values, $this->telefono);
			array_push($values, $this->observaciones);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
		$respuesta = $conn->importar_registro($this->db_nombretabla, $values);
		$this->db_mensaje = $conn->GetMensaje();
		if ( $respuesta ){
			$this->tienda_id = $conn->getlastId();
		};
		return $respuesta;
	}

	public function eliminar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ($this->tienda_id > 0){ // DELETE
			array_push($values, $usuario_editor);
			array_push($values, $this->tienda_id );
			$respuesta = $conn->eliminar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		} else {
			$this->db_mensaje = "No se puede realizar este proceso";
		}
		return $respuesta;
	}
	public function get_mensaje(){
		return $this->db_mensaje;
	}
}

class cls_Group_Tienda {

	protected $db_mensaje = "";
	protected $db_nombre_tabla = "tienda";
	protected $db_nombres_columnas = "*";
	protected $db_filtro = "1";
	protected $db_agrupar = "";
	protected $db_orden_columna = "nombre";
	protected $db_orden_direccion = "ASC";
	protected $db_cantidad = 0;
	protected $db_filtro_datos = array();
	protected $db_filas = array();
	
	public function __construct(){
		$this->db_nombres_columnas = "tienda_id, nombre, imagen, ubicacion, telefono, observaciones, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
		$this->db_orden_columna = "nombre";
	}

	static public function Export($fecha_min, $fecha_max, $ordendireccion="ASC", $ordencolumna="tienda_id", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Tienda();
		$current->db_filtro = "DATE(fecha_creacion) > DATE(?) AND DATE(fecha_creacion) <= DATE(?)";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $fecha_min);
		array_push($current->db_filtro_datos, $fecha_max);
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function Buscar($buscar="", $ordendireccion="ASC", $ordencolumna="nombre", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Tienda();
		$buscar = "%".$buscar."%";
		$current->db_filtro = "nombre LIKE ? AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $buscar );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	public function cargar_datos( $offset, $cantidad ){
		$conn = new cls_Conexion();
		$this->db_filas = $conn->listar_filas( $this->db_nombre_tabla, $this->db_nombres_columnas, $this->db_orden_columna, $this->db_orden_direccion, $this->db_filtro, $this->db_filtro_datos, $offset, $cantidad, $this->db_agrupar );
		$this->db_mensaje = $conn->GetMensaje();
	}
	public function get_cantidad_cargados(){
		return count($this->db_filas);
	}
	public function get_cantidad(){
		return $this->db_cantidad;
	}
	
	public function get_tienda_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["tienda_id"];
			return $val;
		}
		return 0;
	}
	public function get_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["nombre"];
			return $val;
		}
		return "";
	}
	public function get_imagen($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["imagen"];
			return $val;
		}
		return "";
	}
	public function get_ubicacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["ubicacion"];
			return $val;
		}
		return "";
	}
	public function get_telefono($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["telefono"];
			return $val;
		}
		return "";
	}
	public function get_nombres($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["nombres"];
			return $val;
		}
		return "";
	}
	public function get_observaciones($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["observaciones"];
			return $val;
		}
		return "";
	}
	public function get_usuario_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["usuario_modificacion"];
			return $val;
		}
		return 0;
	}
	public function get_fecha_creacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_creacion"];
			return $val;
		}
		return "";
	}
	public function get_fecha_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_modificacion"];
			return $val;
		}
		return "";
	}
	public function get_activo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["activo"];
			return $val;
		}
		return "";
	}
};
?>		
